<template>
  <div class="text-center">
    <v-menu
      v-model="menu"
      :close-on-content-click="false"
      :nudge-width="150"
      transition="slide-y-transition"
      offset-y
    >
      <template v-slot:activator="{ on }">
        <v-btn text color="white" v-on="on">
          <span class="mr-3">Olá, {{ user.name }}</span>
          <v-icon>mdi-chevron-down</v-icon>
        </v-btn>
      </template>
      <v-card class="menuOn">
        <v-list>
          <v-list-item>
            <v-list-item-avatar>
              <!-- <img src="https://cdn.vuetifyjs.com/images/john.jpg" alt="John" /> -->
              <v-icon color="primary" x-large>mdi-account</v-icon>
            </v-list-item-avatar>

            <v-list-item-content>
              <v-list-item-title>{{ user.name }} {{ user.surname }}</v-list-item-title>
              <v-list-item-subtitle>{{ user.email }}</v-list-item-subtitle>
            </v-list-item-content>
          </v-list-item>
        </v-list>
        <v-divider></v-divider>
        <v-list>
          <v-list-item @click="handlePassword">
            <v-list-item-action>
              <v-icon color="primary">mdi-account-key-outline</v-icon>
            </v-list-item-action>
            <v-list-item-title>{{
              $vuetify.lang.t('$vuetify.toolbar.changePassword')
            }}</v-list-item-title>
          </v-list-item>
          <v-list-item @click="handleLogout">
            <v-list-item-action>
              <v-icon color="primary">mdi-logout</v-icon>
            </v-list-item-action>
            <v-list-item-title>Logout</v-list-item-title>
          </v-list-item>
        </v-list>
      </v-card>
    </v-menu>
  </div>
</template>

<script>
import { mapMutations } from 'vuex'
import User from '../../services/user'

export default {
  name: 'Login',
  components: {},
  computed: {
    // userLogged() {
    //   return this.$store.state.user.userInfo
    // },
  },
  created() {
    this.changeName()
  },
  data: () => ({
    menu: false,
    user: {},
  }),
  methods: {
    ...mapMutations('user', ['UPDATE_USER_CHANGE_PASSWORD', 'UPDATE_LOGGED']),
    handlePassword() {
      this.UPDATE_USER_CHANGE_PASSWORD(true)
    },
    //integração backend
    async handleLogout() {
      try {
        let ret = await User.logout()
        if (ret.data.success) {
          this.menu = false
          this.UPDATE_LOGGED(false)
          // await this.$clearStorage()
          await sessionStorage.clear()
          await this.$removeItem('accessKey')
          await this.$removeItem('accessKeyEHQ')
          await this.$removeItem('authenticationKeyEHQ')
          await this.$removeItem('entityChildren')
          await this.$removeItem('logged')
          await this.$removeItem('navEntityHistory')
          await this.$removeItem('rootEntities')
          await this.$removeItem('routedEntity')
          await this.$removeItem('toolbarEntities')
          await this.$removeItem('userEHQ')
          await this.$removeItem('userInfo')
          this.$router.push('/').catch((err) => {})
        }
      } catch (e) {
        console.log(e)
      }
    },
    // fim integração backend

    // métodos frontend
    async changeName() {
      const userInfo = await this.$getItem('userInfo')
      this.user = userInfo
    },

    //fim métodos frontend
  },
}
</script>

<style>
.menuOn {
  animation: menuAppears 0.5s;
}

@keyframes menuAppears {
  from {
    transform: translateY(-35px);
    opacity: 0;
  }

  to {
    transform: translateY(0);
    opacity: 1;
  }
}
</style>
